<script lang="ts">
  import { Input, InputGroup, InputGroupText, Table } from '@sveltestrap/sveltestrap';
  import { onMount } from 'svelte';
  import {eventId} from '@stores';
  import { Gql } from '@db';
  import type { ServicePeriodScore } from '@models/ServicePeriodScore';
  import moment from 'moment';
  import { EventCfgByIdQuery, type EventConfiguration } from "@models/EventConfigurations";
  import Countdown from "@components/Countdown.svelte";

  let periodScores: ServicePeriodScore[] = [];
  let grace = 1;
  $: highest_checks = Math.max(...periodScores.map((p) => p.total_team_checks));
  let eventCfg: EventConfiguration | null = null;

  const query = `
    subscription ServicePeriodStatusScoreboard {
      scoring_service_period_score(
        order_by: {total_team_checks: asc, team_id: asc, check_id: asc}
        where: {
          period: {start: {_lt: "now()"}, end: {_gt: "now()"}},
          event_id: {_eq: "${$eventId}"}
        }
      ) {
        team_id
        check_id
        period_id
        team {
          name
          long_name
        }
        total_team_checks
        check {
          name
        }
        max_checks
        max_points
        score
        successful_team_checks
        period {
          start
          end
        }
      }
    }`;

  onMount(() => {
    Gql.subscribeSimple<{ scoring_service_period_score: ServicePeriodScore[] }>(
      query,
      (data) => (periodScores = data.scoring_service_period_score),
    );

    Gql.subscribeSimple<{ events_by_pk: EventConfiguration }>(
      `subscription ${EventCfgByIdQuery($eventId)}`,
      (data) => (eventCfg = data.events_by_pk)
    );
  });
</script>

<InputGroup class="py-3">
  <InputGroupText>Grace number of checks for error</InputGroupText>
  <Input type="number" bind:value={grace} />
</InputGroup>

<Table>
  <thead>
    <tr>
      <th>Team</th>
      <th>Check</th>
      <th>Checks</th>
      <th>Max Checks</th>
      <th>Checks %</th>
      <th>Points</th>
      <th>Max Points</th>
      <th>Points %</th>
      <th>Period Start</th>
      <th>Period End</th>
      <th>Period Remaining</th>
    </tr>
  </thead>
  <tbody>
    {#each periodScores as p}
      <tr class:table-danger={p.total_team_checks < highest_checks - grace}>
        <td>{p.team?.name}</td>
        <td>{p.check?.name}</td>
        <td>{p.total_team_checks}</td>
        <td>{p.max_checks}</td>
        <td>{((p.total_team_checks / p.max_checks) * 100).toFixed(0)}%</td>
        <td>{p.score.toFixed(0)}</td>
        <td>{p.max_points}</td>
        <td>{((p.score / p.max_points) * 100).toFixed(0)}%</td>
        <td>{moment(p.period?.start).format('LT')}</td>
        <td>{moment(p.period?.end).format('LT')}</td>
        <td>
          {moment.duration(moment(p.period.end) - moment()).humanize()}
          ({moment
            .duration(moment(p.period.end) - moment())
            .asMinutes()
            .toFixed(0)}
          minutes)
        </td>
      </tr>
    {/each}
  </tbody>
</Table>
<div class="py-5" />

{#if eventCfg != null}
  {#key eventCfg}
    <div class="bg-dark" style="position: fixed; bottom: 0; left: 50%">
      <Countdown {eventCfg} id="nav-countdown" placement="bottom" size={18} />
    </div>
  {/key}
{/if}

